import FallBackComponent from '../components/FallbackComponent.svelte';
import Paragraph from '../components/Paragraph.svelte';
import Cover from '../components/layout/Cover.svelte';
import PageLayout from '../components/layout/PageLayout.svelte';
import Text from '../components/base/richtext/component/Text.svelte';
import Theme from '../components/layout/Theme.svelte';
import Heading1 from '../components/Heading1.svelte';
import Heading2 from '../components/Heading2.svelte';
import Heading3 from '../components/Heading3.svelte';
import Column from '../components/Column.svelte';
import ColumnList from '../components/ColumnList.svelte';
import NumberedListItem from '../components/NumberedListItem.svelte';
import BulletedListItem from '../components/BulletedListItem.svelte';
import Todo from '../components/Todo.svelte';
import CheckBox from '../components/CheckBox.svelte';
import Toggle from '../components/Toggle.svelte';
import Quote from '../components/Quote.svelte';
import Callout from '../components/Callout.svelte';
import Equation from '../components/Equation.svelte';
import Code from '../components/Code.svelte';
import Image from '../components/Image.svelte';
import Video from '../components/Video.svelte';
import Divider from '../components/Divider.svelte';
import Audio from '../components/Audio.svelte';
export class NotionComponentProvider {
    map;
    fallBackComponent;
    constructor(map, { fallBackComponent = FallBackComponent } = {}) {
        this.map = { ...defaultComponents, ...map };
        this.fallBackComponent = fallBackComponent;
    }
    register(key, component) {
        this.map[key] = component;
    }
    registerAll(map) {
        this.map = { ...this.map, ...map };
    }
    resolve(key) {
        const target = this.map[key];
        if (target === undefined) {
            return this.fallBackComponent;
        }
        return target;
    }
}
export const defaultComponents = {
    paragraph: Paragraph,
    heading_1: Heading1,
    heading_2: Heading2,
    heading_3: Heading3,
    cover: Cover,
    pageLayout: PageLayout,
    theme: Theme,
    column: Column,
    column_list: ColumnList,
    numbered_list_item: NumberedListItem,
    bulleted_list_item: BulletedListItem,
    to_do: Todo,
    toggle: Toggle,
    quote: Quote,
    callout: Callout,
    equation: Equation,
    code: Code,
    image: Image,
    video: Video,
    divider: Divider,
    audio: Audio,
    // low level custom. 넣을까 말까 고민중.., 
    checkbox: CheckBox,
    text: Text,
};
export const defaultProvider = new NotionComponentProvider({});
